# cache2k 2.2.1.Final "Twofold Bay"

This change log lists the changes since [2.2.0.Final](/2/2.0.Final.html).

## Fixes and Improvements

- `Cache.entries`: throws `IlliegalStateException` if `remove` is called twice on the iterator.
- `Cache.asMap`: aligned to the map contract, `equals`, `hashCode` cooperate with arbitrary maps,
  `toString` is implemented identical to Java maps (e.g. HashMap)

## Credits

Many thanks for the valuable input to the contributors of this release:

- Ben Manes, [Ben Manes](https://github.com/ben-manes), [#174](https://github.com/cache2k/cache2k/issues/174)

## Using this cache2k version

The binaries are available on maven central.

### For Java SE/EE and Android environments

For Maven users:

````
    <dependency>
      <groupId>${project.groupId}</groupId>
      <artifactId>cache2k-api</artifactId>
      <version>2.2.1.Final</version>
    </dependency>
    <dependency>
      <groupId>${project.groupId}</groupId>
      <artifactId>cache2k-core</artifactId>
      <version>2.2.1.Final</version>
      <scope>runtime</scope>
    </dependency>
````

Recommended for Gradle users:

````
def cache2kVersion = '2.2.1.Final'

dependencies {
    implementation "org.cache2k:cache2k-api:${cache2kVersion}"
    runtimeOnly "org.cache2k:cache2k-core:${cache2kVersion}"
}
````

_Note to Android users:_ The included jar files contain code that might only be needed in server environments (e.g. JMX support).
It is possible to strip unnecessary code. Example ProGuard rules can be found at [Andriod - cache2k User Guide](https://cache2k.org/docs/latest/user-guide.html#android)

### Using the JCache / JSR107 provider

Maven users include the cache2k JCache provider this way:

````
    <dependency>
      <groupId>org.cache2k</groupId>
      <artifactId>cache2k-jcache</artifactId>
      <version>2.2.1.Final</version>
      <scope>runtime</scope>
    </dependency>
````

For Gradle users:

````
dependencies {
    runtimeOnly "org.cache2k:cache2k-jcache:2.2.1.Final"
}
````

Implementation details, tuning tips and hints on configuration can be found at: [JCache - cache2k User Guide](https://cache2k.org/docs/latest/user-guide.html#jcache
